unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, EditBtn,
  Grids, Spin, FileUtil;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnFliegermichl: TButton;
    btnWinni: TButton;
    btnFindFiles: TButton;
    btnRunAllTests: TButton;
    DirectoryEdit1: TDirectoryEdit;
    Memo1: TMemo;
    SpinEdit1: TSpinEdit;
    StringGrid1: TStringGrid;
    procedure btnFindFilesClick(Sender: TObject);
    procedure btnFliegermichlClick(Sender: TObject);
    procedure btnRunAllTestsClick(Sender: TObject);
    procedure btnWinniClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure CountFiles(path : string; var dirs, files : integer);
    function TreeCount (StartDir : String) : integer;

    procedure runFliegermichl;
    procedure runWinni;
    procedure runFindAllFiles;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btnFliegermichlClick(Sender: TObject);
var
  i:integer;
begin
  for i:=1 to SpinEdit1.Value do begin
    Memo1.Append('Fliegermichl '+inttostr(i));
    runFliegerMichl;
    Application.ProcessMessages;
  end;
end;

procedure TForm1.btnRunAllTestsClick(Sender: TObject);
begin
  Memo1.Append('Serientest beginnt ');
  btnFliegermichlClick(self);
  btnWinniClick(self);
  btnFindFilesClick(self);
  Memo1.Append('Serientest beendet ');
end;

procedure TForm1.btnFindFilesClick(Sender: TObject);
var
  i:integer;
begin
  for i:=1 to SpinEdit1.Value do begin
    Memo1.Append('FindAllFiles '+inttostr(i));
    runFindAllFiles;
    Application.ProcessMessages;
  end;

end;

procedure TForm1.btnWinniClick(Sender: TObject);
var
  i:integer;
begin
  for i:=1 to SpinEdit1.Value do begin
    Memo1.Append('Winnie '+inttostr(i));
    runWinni;
    Application.ProcessMessages;
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
var
  row:integer;
begin
  DirectoryEdit1.Text:='C:\Laz2011_Lazfixes20_FPCfixes32';

  StringGrid1.Cells[0,0]:='Method';
  StringGrid1.Cells[1,0]:='Files';
  StringGrid1.Cells[2,0]:='Directories';
  StringGrid1.Cells[3,0]:='Time';
end;

procedure TForm1.CountFiles(path: string; var dirs, files: integer);
var sr : TSearchRec;
     i : integer;
begin
  i := FindFirst(path + DirectorySeparator + AllFilesMask, faAnyFile, sr);
  while (i = 0) do
  begin
    if (sr.name <> '.') and (sr.Name <> '..') then
    begin
      if (sr.Attr and faDirectory <> 0) then
      begin
        inc(dirs);
        CountFiles(path + DirectorySeparator + sr.Name, dirs, files);
      end else
      begin
        inc(files);
      end;
    end;
    i := FindNext(sr);
  end;
  FindClose(sr);
end;

function TForm1.TreeCount(StartDir: String): integer;
var search : TSearchRec;
    DirAttr : integer;
begin
{$IFDEF LINUX} DirAttr := 48;
{$ELSE} DirAttr := faDirectory;
{$ENDIF}
result := 0;
if startDir[length(startDir)] <> DirectorySeparator then
   startDir := startDir + DirectorySeparator;

if findFirst(startDir + AllFilesMask, faAnyFile, search) = 0 then
    begin
    repeat
      if (search.name = '.') or (search.name = '..') then Continue;
      if (search.Attr = DirAttr) then result := result + TreeCount(startDir+search.Name) else
           inc (result);
    until FindNext(search) <> 0;
    end;
findClose(search);

end;

procedure TForm1.runFliegermichl;
var dirs, files : integer;
    StartTime, EndTime : QWord;
    row:integer;
begin
 dirs := 0;
 files := 0;

 StartTime := GetTickCount64;
 CountFiles(DirectoryEdit1.Directory, dirs, files);
 EndTime := GetTickCount64;

 row := StringGrid1.RowCount;
 StringGrid1.RowCount := row + 1;
 StringGrid1.Cells[0,row]:='FM';
 StringGrid1.Cells[1,row]:=inttostr(files);
 StringGrid1.Cells[2,row]:=inttostr(dirs);
 StringGrid1.Cells[3,row]:=IntToStr (EndTime-StartTime);

end;

procedure TForm1.runWinni;
var files : Integer;
    StartTime, EndTime : QWord;
    row:integer;
begin
   StartTime := GetTickCount64;
   files := treecount(DirectoryEdit1.Text);
   EndTime := GetTickCount64;

   row := StringGrid1.RowCount;
   StringGrid1.RowCount := row + 1;
   StringGrid1.Cells[0,row]:='Winnie';
   StringGrid1.Cells[1,row]:=inttostr(files);
   //StringGrid1.Cells[2,row]:=inttostr(dirs);
   StringGrid1.Cells[3,row]:=IntToStr (EndTime-StartTime);
end;

procedure TForm1.runFindAllFiles;
var
  ResultFiles: TStringList;
  StartTime, EndTime : QWord;
  row:integer;
begin
  ResultFiles := TStringList.Create;
  try
    StartTime := GetTickCount64;

    //FindAllFiles(ResultFiles, DirectoryEdit1.Text, '*.pas;*.pp;*.p;*.inc', true); //find e.g. all pascal sourcefiles
    FindAllFiles(ResultFiles, DirectoryEdit1.Text, AllFilesMask, true);

    EndTime := GetTickCount64;


    row := StringGrid1.RowCount;
    StringGrid1.RowCount := row + 1;
    StringGrid1.Cells[0,row]:='FindAllFiles';
    StringGrid1.Cells[1,row]:=inttostr(ResultFiles.Count);
    //StringGrid1.Cells[2,row]:=inttostr(dirs);
    StringGrid1.Cells[3,row]:=IntToStr (EndTime-StartTime);

  finally
    ResultFiles.Free;
  end;



end;



end.

